import Test.HUnit
import Test.QuickCheck.Batch

import Cidr (cidr_tests,
             prop_all_cidrs_contain_themselves,
             prop_contains_proper_intransitive)

import IPv4Address (ipv4address_tests)
import Octet (octet_tests)

-- The list of HUnit tests.
test_suite = TestList (concat [cidr_tests,
                               ipv4address_tests,
                               octet_tests])

-- QuickCheck options
options = TestOptions { no_of_tests     = 1000,
                        length_of_tests = 0, -- No time limit on tests.
                        debug_tests     = False }

main :: IO ()
main = do
  putStrLn "HUnit"
  putStrLn "-----"
  runTestTT test_suite

  putStrLn ""

  putStrLn "QuickCheck"
  putStrLn "----------"
  runTests "Cidr" options [ run prop_all_cidrs_contain_themselves,
                            run prop_contains_proper_intransitive]
